﻿Module Module1

    Sub Main()
        'declare variables and prepare some things for later use.
        Dim strsourcepath As String = "\\test-path\\"
        Dim strAppname As String = "SoundVolumeView.exe"
        Dim strIstFolder As String = ""
        Dim strSolFolder As String = ""
        Dim strCompname As String = My.Computer.Name
        Dim commandlimeargs As String() = Nothing
        Dim strfilename As String = ""
        Dim srFilereader As System.IO.StreamReader = Nothing
        Dim p As New Process()
        Dim pStartInfo As New ProcessStartInfo()
        Dim pset As New Process()
        Dim psetStartInfo As New ProcessStartInfo()
        Dim strLine As String = ""
        Dim strsplit As String() = Nothing
        Dim strDeviceName As String = ""
        Dim bDebug As Boolean = False

        Try
            'create a filename to use for saving the csv file (computername_date_without spaces and :)
            strfilename = strCompname & "_Audio_" & Date.Now
            strfilename = Replace(strfilename, " ", "_", 1,, CompareMethod.Text)
            strfilename = Replace(strfilename, ":", "-", 1,, CompareMethod.Text)
            commandlimeargs = Environment.GetCommandLineArgs()
            'check for arguments and take proper action
            For i = 0 To commandlimeargs.Length - 1

                If commandlimeargs(i).ToLower.ToString = "-path" Then
                    strsourcepath = commandlimeargs(i + 1)
                End If
                If commandlimeargs(i).ToLower.ToString = "-debug" Then
                    bDebug = True
                End If
            Next i
            'set folder location for file storage
            strIstFolder = strsourcepath & "\" & "Ist\"
            strSolFolder = strsourcepath & "\" & "Sol\"
            'peroare process to launch SoundVolumeView.exe
            pStartInfo.FileName = strsourcepath & "\" & strAppname
            If bDebug = True Then
                Console.WriteLine("Creating file : " & strIstFolder & strfilename & ".csv")
            End If
            'set parameters for SoundVolumeView.exe to create csv file
            pStartInfo.Arguments = "/scomma " & strIstFolder & strfilename & ".csv"
            'hide SoundVolumeView.exe window
            p.StartInfo.CreateNoWindow = True
            p.StartInfo = pStartInfo
            ' start process
            p.Start()
            p.WaitForExit(60000) ' wait for the process to finish and continue after 60 seconds if process isn't finished

            'prepare cvs file for reading
            srFilereader = New System.IO.StreamReader(strIstFolder & strfilename & ".csv")



            'read cvs file to prefprm actions
            While srFilereader.Peek > -1
                strLine = srFilereader.ReadLine
                strsplit = Split(strLine, ",", , CompareMethod.Text)
                'check for device entries
                If strsplit(1).ToLower.ToString = "device" Then
                    If bDebug = True Then
                        Console.WriteLine("Found device : " & strsplit(0).ToString)
                    End If
                    'prepare process to set volume based on csvfile entries
                    psetStartInfo.FileName = strsourcepath & "\" & strAppname
                    If bDebug = True Then
                        Console.WriteLine("Settig volume to 100 % for device : " & strsplit(0).ToString)
                    End If
                    'set volume of device
                    psetStartInfo.Arguments = "/setvolume " & Chr(34) & strsplit(0).ToString & Chr(34) & " " & "100"
                    pset.StartInfo = psetStartInfo
                    pset.Start()
                    pset.WaitForExit(60000)
                    If bDebug = True Then
                        Console.WriteLine("Unmuting device : " & strsplit(0).ToString)
                    End If
                    'unmute device
                    psetStartInfo.FileName = strsourcepath & "\" & strAppname
                    psetStartInfo.Arguments = "/Unmute " & Chr(34) & strsplit(0).ToString & Chr(34)
                    pset.StartInfo = psetStartInfo
                    pset.Start()
                    pset.WaitForExit(60000)
                    If bDebug = True Then
                        Console.WriteLine("Finished configuring device : " & strsplit(0).ToString)
                    End If
                End If

            End While

            If bDebug = True Then
                Console.WriteLine("Creating file : " & strSolFolder & strfilename & ".csv")
            End If
            'create csv file containing results
            pStartInfo.Arguments = "/scomma " & strSolFolder & strfilename & ".csv"
            p.StartInfo.CreateNoWindow = True
            p.StartInfo = pStartInfo
            p.Start()
            p.WaitForExit(60000)

            Threading.Thread.Sleep(10000)
            srFilereader.Close()
        Catch ex As Exception
            Console.WriteLine("Something went wrong see error description below :")
            Console.WriteLine(ex.ToString)
            Threading.Thread.Sleep(10000)
        End Try
    End Sub

End Module
